<%

##
## Tree widget
##
## On entry:
##   PATH_TRANSLATED: Name of source data file
##   QUERY_STRING: <open command>,target
##

%>

<html>
<body bgcolor="#ffffff"><font size=-1>

<%

##
## Returns the file data
##

proc getdata { file } {
    # Use the webserver cache

    return [server::cache $file]
    
    # Slow code to read off disk directly
    #set fd [open $file]
    #set content [read $fd]
    #close $fd
    #return $content    
}


namespace eval widget {

    variable level 0
    variable prevlevel 0
    variable displaylevel 0
    variable prevname ""
    variable prevlocation ""
    variable arg 
    variable argindex 0
    variable target

    variable open_graphic    "/apps/admin/open.gif"
    variable closed_graphic  "/apps/admin/closed.gif"

    variable url "$request::env(SCRIPT_NAME)$request::env(PATH_INFO)"	
    
    ##
    ## Parses the file data
    ##
    ## name, url  <- root level book
    ##  name, url  <- level1 entry
    ##  name, url  <- level1 entry
    ##   name, url <- level 2 entry
    ## name, url  <- root level book
    ##
    ## if url begins with a '#', the parent's url is prefixed to it
    ##
    
    proc parse { data } {
	variable level
	variable prevlevel
	variable displaylevel
	variable prevname
	variable prevlocation
	variable defaultloc
	variable arg
	variable argindex
	variable target

	if { [regexp "(\[01]*),(.*)" $request::env(QUERY_STRING) \
		tmp arg target] == 0 } {
	    asp::write "Invalid query"
	    return
	}

	set defaultloc ""

	# magic!
	append data "\nsentinel!"

	foreach line [split $data "\n"] {
	    if { [ string index $line 0 ] == "#" } { continue }
	    if { [ string length $line ] == 0 }    { continue }

	    set tmp ""
	    set name ""
	    set location ""

	    if { [regexp "^(.*),\[ \t]*(.*)$" $line tmp name location ] 
	    == 0 } { 
		set name $line;
		set location "";
	    }

	    # Now strip leading ' 's off name to get the level
	    set level 0
	    while { [ string index $name $level ] == " " } {
		incr level
	    }
	    set name [string trimleft $name]
	    
	    # Now for the science bit, are you paying attention?
	    if { $level > $prevlevel } {
		if { [expr $level - $prevlevel] > 1 } {
		    error "Multiple level jump in file"
		}
		if { [expr $argindex+1] > [string length $arg] } {
		    set i 0 
		} else { 
		    set i [string index $arg $argindex] 
		}
		incr argindex
		if { $i && $level == [expr $displaylevel+1]} \
			{ incr displaylevel }
	    } elseif { $level < $prevlevel } {
		if { $level < $displaylevel } { set displaylevel $level }
	    }

	    if { $prevname != "" } { display }

	    if { $level == $displaylevel } { 
		set prevname $name
		if { [ string index $location 0 ] == "#" } { 
		    set location "$defaultloc$location"
		}
		set prevlocation $location
	    } else {
		set prevname ""
	    }
	    
	    set prevlevel $level
	}
    }
    

    proc newarg { type } {

	variable arg
	variable argindex

	if { $type == "open" } {
	    set newarg [string range $arg 0 [expr $argindex-2]]
	    while { [ string length $newarg ] < [expr $argindex-1] } {
		append newarg "0"
	    }
	    append newarg "0"
	    append newarg [string range $arg [expr $argindex+0] end]
	} elseif { $type == "close" } {
	    set newarg [string range $arg 0 [expr $argindex-2]]
	    while { [ string length $newarg ] < [expr $argindex-1] } {
		append newarg "0"
	    }
	    append newarg "1"
	    append newarg [string range $arg [expr $argindex+0] end]
	} else { error "Invalid argument" }

	return $newarg
    }


    proc display {} {

	variable level
	variable prevlevel
	variable displaylevel
	variable prevname
	variable prevlocation
	variable arg
	variable argindex
	variable target
	variable defaultloc

	variable url
	variable open_graphic
	variable closed_graphic

	set spacer "";
	for { set i $prevlevel } {$i > 0} { incr i -1 } { 
	    append spacer "&nbsp;" 
	}

	if { $level > $prevlevel } {
	    # This must mean the last line was a branch with children
	    set defaultloc $prevlocation
	    # Now decide if we need a '+' or a '-'
	    set newarg ""
	    if { $level == $displaylevel } { 
		set type "<img src=\"$open_graphic\" border=0 alt=\[-]>"
		set newarg [newarg open]

		if { $prevlocation == "" } {
		    set prevlocation $url?$newarg,$target
		} else {
		    set prevlocation "$prevlocation\" target=\"$target\""
		}

	    } else { 
		set type "<img src=\"$closed_graphic\" border=0 alt=\[+]>"
		set newarg [newarg close]
		if { $prevlocation == "" } {
		    set prevlocation $url?$newarg,$target
		} else {
		    set prevlocation "$prevlocation\" target=\"$target\""
		}
	    }
	    if { $prevlocation != "" } {
		set prevname "<a href=\"$prevlocation\">$prevname</a>"
	    }
	    asp::write "<br>$spacer\
		    <a href=\"$url?$newarg,$target\">$type</a> $prevname\n"
	} else {
	    asp::write "<br>$spacer&nbsp;&nbsp;\
		    <a href=\"$prevlocation\" target=\"$target\">\
		    $prevname</a>\n";
	}

    }

}

widget::parse [getdata $request::env(PATH_TRANSLATED)]
%>

</font>
</body>
</html>
