# Builds on ASP support to provide services for Zeus Admin Server Pages
#
# Source requirements
#   asp.tcl
#
# Feature requirements
#   reg

namespace eval zap {

    ##
    ## zap::error message
    ##
    ## Eats an already written data, outputs an error page to the client
    ## and stops further ASP processing.

    proc error { message } {
	set result ""
	append result "<html>\n"
	append result "<head><title>Error</title></head>\n"
	append result "<body bgcolor=#ffffff>\n"
	append result "<font size=+5>Error:</font><br>"
	append result $message
	append result "</body></html>"

	asp::reset
	asp::write $result
	asp::stop
    }

    ## Define some 'safe' registry interfaces that don't error on failure

    proc regget { setting } {
	if [ catch { reg::get $setting } result ] return ""
	return $result
    }
    
    proc reglist { setting } {
	if [ catch { reg::list $setting } result ] return {}
	return $result
    }

    ##
    ## Form processing
    ##
    ## Decodes the form input and checks it is complete
    ## Argument is a list of required fields

    proc getrequest { required } {
	asp::decode_input
	foreach item $required {
	    if {[info exists asp::input($item)] == 0} {
		zap::error "Missing form element $item"
	    }
	}
    }
}
