<%
# First off, ensure this page isn't cached, otherwise it can be very
# confusing!

response::setheader "Pragma" "no-cache"
response::setheader "Expires" \
  [clock format [clock seconds] -format "%a, %d %b %Y %T %Z" -gmt yes]
%>

<html>
<head>
<title>Zeus Web Server Controller</title>
</head>

<body bgcolor="#ffffff" link=#990066 vlink=#990066 alink=#990066>

<table border=0>
<tr>
  <td valign=top>
    <img src="title.gif" hspace=10 alt="">
    <p align=right>
  <a
  href="/apps/admin/docsystem/context.asp?help=/apps/web/docs/controller/controller.html" target=help onClick=
  "window.open('','help','resizable=1,width=640,height=500'); return true;">
<img src="/apps/web/docs.gif" 
  alt="[documentation]" align=bottom border=0 hspace=0></a>
    <a href="/"><img src="back.gif" alt="[back]" align=bottom border=0 hspace=0></a>
  </td>
  <td>

<img src="status.gif" alt="Status"><p>

<%
proc debug { str } {
    asp::write "<pre>$str</pre>"
}

#############################################################################
# Attempts to connect with a timeout, either errors or returns a 
# socket channel (blocking)
#
proc connect_timeout { host port timeout } {
    global connect_timeout ;# global table for our state info
    set connect_timeout(connected) ""
    set connect_timeout(socket) [socket -async $host $port]
    set t [expr $timeout*1000]
    set connect_timeout(timeoutid) [after $t { 
	close $connect_timeout(socket)
	set connect_timeout(connected) "no"
    }]
    fileevent $connect_timeout(socket) writable { 
	after cancel $connect_timeout(timeoutid)
	set connect_timeout(connected) "yes"
    }
    # Now wait if we didn't manage it straight away....
    if { $connect_timeout(connected) == "" } { 
	vwait connect_timeout(connected) 
    }
    if { $connect_timeout(connected) == "yes" } { 
	# Ensure we are back blocking again
	fconfigure $connect_timeout(socket) -blocking yes 
	return $connect_timeout(socket) 
    }
    error "Connect timeout"
}

#############################################################################
# Routines to determine which sites to render

namespace eval sites {
    variable startsite 
    variable endsite   
    variable pagesize  10
    variable oldpagesize 10
    variable sitelist
    variable banner ""

    ########################################################################
    # Determines values for startsite & endsite from arguments

    proc init { sites } {
	variable startsite
	variable endsite
	variable siteslist
	variable pagesize
	variable oldpagesize

	set siteslist $sites
	set startsite 0
	set endsite [expr [llength $siteslist] -1]
	if { $endsite == -1 } { set endsite 0 }

	asp::decode_input
	if { [info exists asp::input(start)] } { 
	    set startsite $asp::input(start)
	}
	if { [info exists asp::input(pagesize)] } {
	    set pagesize $asp::input(pagesize)
	}
	if { [info exists asp::input(oldpagesize)] } {
	    set oldpagesize $asp::input(oldpagesize)
	}

	if { $startsite > $endsite } {
	    set startsite [expr $endsite - $pagesize + 1 ]
	    if { $startsite < 0 } { set startsite 0 }
	}
	if { $pagesize!=-1 && [expr $startsite + $pagesize - 1] < $endsite } {
	    set endsite [expr $startsite + $pagesize - 1]
	}
    }

    ########################################################################
    # Returns 1 if it all fits on one page

    proc fits {} {
	variable startsite
	variable endsite
	variable siteslist

	if { $startsite == 0 && $endsite == [expr [llength $siteslist]-1] } {
	    return 1
	} else { return 0 }
    }

    ########################################################################
    # Given a list of websites in sorted order, chooses which ones we want to
    # display

    proc choose {} {
	variable startsite
	variable endsite
	variable siteslist

	return [lrange $siteslist $startsite $endsite]
    }

    ########################################################################
    # Draws a header bar

    proc header {} {
	variable banner
	variable pagesize
	variable oldpagesize

	if { $banner != "" } { 
	    # Cached
	    asp::write $banner
	    return
	}

	if { $pagesize == -1 } {
	    set banner ""
	    append banner "<a href=\"index.zap?pagesize=$oldpagesize\">Back to partial display</a>"
	    asp::write $banner
	}

	if { [fits] } { return }

	variable startsite
	variable endsite
	variable siteslist
	variable pagesize

	set prevpage [expr $startsite - $pagesize]
	if { $prevpage < 0 } { set prevpage 0 }
	set nextpage [ expr $startsite + $pagesize]

	append banner "<font size=-1>"
	if { $startsite != 0 } {
	    append banner "<a href=\"index.zap?start=0&pagesize=$pagesize\">&lt;&lt;</a> | "
	    append banner "<a href=\"index.zap?start=$prevpage&pagesize=$pagesize\">&lt;</a> | "
	} else {
	    append banner "<font color=gray>&lt;&lt;</font> | "
	    append banner "<font color=gray>&lt;</font> | "
	}

	# Now the quick jump ones
	foreach section [list AF GL MR SZ] {
	    set start [string index $section 0]
	    set end   [string index $section 1]
	    set index 0
	    foreach site $siteslist {
		set usite [string toupper $site]
		if { $usite >= $start } { break }
		incr index
	    }
	    append banner " <a href=
	    \"index.zap?start=$index&pagesize=$pagesize\">$start-$end</a> | "
	}

	if { $endsite != [expr [llength $siteslist]-1] } {
	    append banner "<a href=\"index.zap?start=$nextpage&pagesize=$pagesize\">&gt;</a>"
	    append banner " | <a href=\"index.zap?start=[expr [llength $siteslist]-$pagesize]&pagesize=$pagesize\">&gt;&gt;</a>"
	} else {
	    append banner "<font color=gray>&gt;</font>"
	    append banner " | <font color=gray>&gt;&gt;</font>"
	}
	append banner " | <a href=\"index.zap?pagesize=-1&oldpagesize=$pagesize\">ALL</a>";
	append banner "</font>"
	asp::write $banner
    }

    ########################################################################
    # Draws a footer bar
    
    proc footer {} { header }
}

############################################################################
# Need to render some traffic lights showing the status of the servers.
#

# First, lets determine if any webservers are alive.
#
# non-zero if any webserver processes are alive
set webserver_alive 0
# set to the number of webservers we have installed
set webserver_installed 0
# non-zero if there is 1 webserver, and its local
set webserver_local 0

set hostsfile "$request::env(ZEUSHOME)/webadmin/conf/hosts"
catch {
    # Read the contents of the hosts file to see what websites we have
    # configured.
    set f [open $hostsfile]
    set data [read $f]
    close $f

    set webserver_installed [ llength $data ]
    if { $webserver_installed == 1 } {
	# split server into host:port
	regexp (.*):(\[0-9]+) $data tmp host port
	if { $host == "localhost" } { set webserver_local 1 }
    }

    # If we can connect to any one of these, we have a running server
    foreach server $data {
	#if { $webserver_alive } { break }
	# split server into host:port
	regexp (.*):(\[0-9]+) $server tmp host port
	# Try to connect to host:port
	catch {
	    set s [ connect_timeout $host $port 2 ]
	    puts $s "info\n"; flush $s
	    set tmp [ read $s ]
	    close $s

	    # must be alive
	    incr webserver_alive
	}
    }
}

#############################################################################

# Depending on whether the webserver is running or not, provide
# a link to start or stop the webserver process.
# Note this is different in the clustering case

if { $webserver_installed == 0 } {
      asp::write "<i>No webserving machines in the server farm are configured.  <a href=cluster/settings.zap>Register machine</a>.</i>"
} else {
  if { $webserver_alive } {
      if { $webserver_local } {
	  asp::write "Webserver running"
          asp::write " (<a href=\"http.cgi?stop\">Stop</a>)"
      } else {
	  asp::write "$webserver_alive/$webserver_installed Webserver(s) running"
      }
  } else {
      if { $webserver_local } {
	  asp::write "Webserver not running"
	  asp::write " (<a href=\"http.cgi?start\">Start</a>)"
      } else {
	  asp::write "No machines in server farm running."
      }
  }
}

asp::write "<p>"

# Now draw the result tables, with the appropriately coloured
# traffic lights depending on what is going on.  At this point
# running and webserver_alive are accurate

# Work out what sites we have
cd $request::env(ZEUSHOME)/webadmin/conf/sites
set configuredservers ""
catch { set configuredservers [glob *] }
# Work out what sites are/should be running
array set running {}
cd $request::env(ZEUSHOME)/webadmin/conf/runningsites
set runningservers ""
catch { set runningservers [glob *] }
foreach server $runningservers {
    set running($server) 1
}

if { [llength $configuredservers] == 0 } {
    # No websites setup
    asp::write "<i>No servers available to configure, please 
    <a href=new.asp>create one</a>.</i>"
} else {
    # Have some websites
    sites::init [lsort -dictionary $configuredservers]
    asp::write "<center>\n";
    sites::header
    asp::write "<table border=1 cellspacing=1 cellpadding=5>\n"
    foreach server [sites::choose] {
	# Draw website $server
	set branch "conf!web!servers!$server"
	set port   [zap::regget "$branch!port" ]
	set ipname [zap::regget "$branch!ip_name" ]
	set secure [zap::regget "$branch!security!enabled" ]

	# Work out the name of the website
	set name "http://$ipname"
	if { $secure == "yes" } { 
	    set name "https://$ipname"
	    if { $port != "443" } { append name ":$port" }
	} else {
	    if { $port != 80 } { append name ":$port" }
	}

	# Work out the graphics and alt tags, and the click action location
	set alt ""
	set graphic ""
	# TODO, need to set this action jobbie soon...
	set action ""

	if { $webserver_alive } {
	    if { [info exists running($server)] } {
		set alt     "running"
		set graphic "green.gif"
		set action  "website.zap?website=$server&action=stop"
	    } else {
		set alt     "stopped"
		set graphic "red.gif"
		set action  "website.zap?website=$server&action=start"
	    }
	} else {
	    if { [info exists running($server)] } {
		set alt     "was running"
		set graphic "green_grayed.gif"
	    } else {
		set alt     "was stopped"
		set graphic "red_grayed.gif"
	    }
	}

	# Now draw the cells
	asp::write "<tr><td><a href=\"$action\"><img border=0 src=\"$graphic\"
	alt=\"\[$alt\]\"></a></td>"

	asp::write "<td>$server"

	# modified test
	if { [info exists running($server)] } {
	    file stat $request::env(ZEUSHOME)/webadmin/conf/sites/$server mtime1
	    file stat $request::env(ZEUSHOME)/webadmin/conf/runningsites/$server mtime2
	    if { $mtime1(mtime) > $mtime2(mtime) } {
		asp::write " <i>(modified)</i>";
	    }
	}

	asp::write "<br><i>"
	if { $webserver_alive && [info exists running($server)] } {
	    asp::write "<a href=\"$name\" target=\"running website\">$name</a>"
	} else {
	    asp::write "<font color=#808080>$name</font>"
	}
	asp::write "</i></td>"

	asp::write "<td><a href=\"edit.zap?server=$server\">
	<img src=edit.gif border=0 alt=\"\[edit\]\"></a></td></tr>"
    }
    asp::write "</table>"

    sites::footer
    asp::write "</center>"
}
%>

<p><br><img src="actions.gif" alt="Actions"><p>

<center>
<table cellspacing=10>
<tr>
  <td align=center>
  <a href=new.asp><img src="button-new.gif" alt="" border=0></a>
  </td>
  <td align=center>
  <a href=cluster/status.zap><img src=cluster/button-cluster.gif alt="" border=0></a>
  </td>
</tr>

<tr>
  <td align=center>
  <a href=new.asp>New server</a><br>
  </td>
  <td align=center>
  <a href=cluster/status.zap>Clustering</a><br>
  </td>
</tr>
</table>

</center>

</td>
</tr>
</table>


</body>
</html>
