<! Required variables
   server
>
$$set _base=conf!web!servers!$$server;!modules!cgi;
$$set help=/apps/web/docs/modules/cgi/index.html;
<title>$$server; - CGI Configuration</title>

$$set edittitle=CGI Configuration;
$$include /../header.asp;

The traditional and most widely used method of including dynamic
elements in your pages is through the Common Gateway Interface (CGI)
programs. CGI programs are run by the server and their output passed
back to the client.  This allows entire pages to be generated "on the
fly". CGI programs can be interpreted scripts or compiled
programs. Any language which supports standard input for reading,
standard output for writing and can read environment variables can be
used to create CGI programs. The simplicity of the CGI interface
allows programs to be built quickly and easily.

<p><hr size=1 width=80%> 

<dl>
<dt><font size=+1><b>Access restrictions</b></font>
<dd>

The server can be configured to run CGIs anywhere in the document
tree, or only in special script directories (such as those setup by
the map module).

<form action="/apps/admin/regupdate.cgi" method=post>
<input type=hidden name=_base value="$$_base;">
<input type=hidden name=_redirect value="$$back;">
<dl>
<dd>

<input type=radio value=yes name=_add_boolean_allowanywhere
 $$if allowanywhere=yes; checked=yes $$endif; > Allow anywhere
<br>
<input type=radio value=no name=_add_boolean_allowanywhere
 $$if allowanywhere=no; checked=yes $$endif; > Restrict to designated
 directories
</dl>

<p>Allow SSI exec cmd (only available if CGIs non-restricted)

<dl>
<dd>
<input type=radio value=yes name=_add_boolean_allowcmd
 $$if allowcmd=yes; checked=yes $$endif; > Yes
<input type=radio value=no name=_add_boolean_allowcmd
 $$if allowcmd=no;  checked=yes $$endif; > No
</dl>
<br>

<input type=submit value=Update>
</form>
</dl>


<dl>
<dt><font size=+1><b>Environment variables</b></font>
<dd>

As well as the standard CGI/1.1 environment variables, here you can
specify extra variables to also be passed to CGIs.

<p>
$$set _base2=$$_base;;
$$set _base=conf!web!servers!$$server;!env;


$$if extra=yes;
  <form action="/apps/admin/regupdate.cgi" method=post>
  <input type=hidden name=_base value="$$_base;">
  <table border=5>
     $$for i in extra;
     <tr>     
       <td bgcolor=#aaaaaa>$$i;=$$extra!$$i;;</td>
       <td><input type=submit name="extra!_del_$$i;" value=Delete></td>
     </tr>
     $$next;
  </table>
</form>
$$else;
<i>No extra variables are currently defined.</i>
$$endif;
<p>

<form action="/apps/admin/regupdate.cgi" method=post>
<input type=hidden name=_base value="$$_base;">
<table>
  <tr>
     <td>Variable name</td>
     <td><input type=text size=20 value="" name="extra!_addbr_text_id1"></td>
  </tr>
  <tr>
     <td>Variable value</td>
     <td><input type=text size=20 value="" name=id1></td>
     <td><input type=submit value=Add></td>
  </tr>
</table>
</form>
</dl>
$$set _base=$$_base2;;

<dl>
<dt><font size=+1><b>Sandboxing</b></font>
<dd>

Sandboxing allows you to increase CGI security.  See the documentation
system for detailed information on the options below.

<form action="/apps/admin/regupdate.cgi" method=post>
<input type=hidden name=_base value="$$_base;">
<input type=hidden name=_redirect value="$$back;">
 <dl>
   <dt><b>Ulimit configurables</b>
   <dd>
   <i>Note: these options have no effect on some platforms</i>.<br>
      Zero indicates that no limit enforced.

   <table>
   <tr>
     <td>Max CPU time:</td>
     <td><input type=text size=10 value="$$ulimitcpu;"
     name=_add_integer_ulimitcpu> seconds</td>
   </tr>
   <tr>
     <td>Max Address space:</td>
     <td><input type=text size=10 value="$$ulimitas;"
     name=_add_integer_ulimitas> bytes</td>
   </tr>
   <tr>
     <td>Max data segment:</td>
     <td><input type=text size=10 value="$$ulimitdata;"
     name=_add_integer_ulimitdata> bytes</td>
   </tr>
   <tr>
     <td>Max processes<br>available to CGI user:</td>
     <td><input type=text size=10 value="$$ulimitnproc;"
     name=_add_integer_ulimitnproc></td>
   </tr>
   </table>

   
   <dt><b>Security configurables</b>
   <dd>
   <i>Note: these options only have effect when the webserver is started as
   root</i><p>

   <input type=radio value=yes name=_add_boolean_autoid
   $$if autoid=yes; checked=yes $$endif;> Run CGI as file owner
   <br>
   <input type=radio value=no name=_add_boolean_autoid
   $$if autoid=no; checked=yes $$endif;> Run as uid/gid
   <dl>
   <dd>
   uid: <input type=text size=10 value="$$uid;" name=_add_text_uid>
   gid: <input type=text size=10 value="$$gid;" name=_add_text_gid>
   </dl>
   <br>
   <input type=radio value=yes name=_add_boolean_chroot
   $$if chroot=yes; checked=yes $$endif;> Run CGI scripts chrooted
   <br>
   <input type=radio value=no name=_add_boolean_chroot
   $$if chroot=no; checked=no $$endif;> Don't run CGI scripts chrooted
   <p>
 </dl>  
 <input type=submit value=Update>

</form>

<dl>
<dt><b>Chroot Jails</b>
<dd>
   If chrooting is enabled, any directories specified here will be
   used to chroot to before executing a CGI below the specified
   directory.  If no directories are set, then the server will chroot
   to the directory in which the CGI lives before executing.

$$if chroot_dirs=yes;
   <form action="/apps/admin/regupdate.cgi" method=post>
   <input type=hidden name=_base value="$$_base;">

   <table border=5>
     <tr>
      <td bdcolor=#aaaaaa><b>chroot jail directory</b></td>
     </tr>
     $$for i in chroot_dirs;
        <tr>
          <td bgcolor=#cccccc>$$i;</td>
          <td bgcolor=#cccccc>$$chroot_dirs!$$i;;</td>
          <td><input type=submit name="chroot_dirs!_del_$$i;"
	  value=Delete></td>
        </tr>
     $$next;
   </table>
   </form>

$$else;
<p><i>No jail directories currently defined.</i>
$$endif;

   <p><dt><b>Add Jail directory</b>
   <dd>
   <form action="/apps/admin/regupdate.cgi" method=post>
   <input type=hidden name=_base value="$$_base;">
   Directory: 
   <input type=text size=30 value="" name="chroot_dirs!_addbr_text_id1">
   <input type=hidden       value="" name="id1">
   <input type=submit value=Add>
   </form>
</dl>

</dl>


$$include /../footer.asp;
