<! Required variables
   server>

$$set _base=conf!web!servers!$$server;!modules!fastcgi;
$$set help=/apps/web/docs/modules/fastcgi/index.html;

<title>$$server; - FastCGI Configuration</title>

$$set edittitle=FastCGI Configuration;
$$include /../header.asp;


This module provides support for FastCGI, an open extension to CGI
which provides much higher performance and greater functionality.
For more information about FastCGI, see the official website at 
<a href="http://www.fastcgi.com">http://www.fastcgi.com</a>.

<p>

FastCGIs are executed in FastCGI alias directories setup by the <a
href="/apps/web/modules/map/config.asp?server=$$server;&back=$$back;">map
module</a>.  More information about how to setup FastCGI is available
in the <a href="$$help;">documentation system</a>.

<hr size=1 width=80%>

<dl>
<dt><font size=+1><b>Remote FastCGIs</b></font>
<dd>

FastCGIs can be setup to run on a different machine than the
webserver.  Simply specify the URL of the FastCGI (which should be
inside a FastCGI alias) which is to run remotely, and the details of
where the FastCGI lives on the network.

<p>
$$if remote=yes;
  <form action="/apps/admin/regupdate.cgi" method=post>
  <input type=hidden name=_base value="$$_base;">
  <table border=5>
    <tr>
      <td bgcolor=#aaaaaa><b>Docroot path</b></td>
      <td bgcolor=#aaaaaa><b>Host:Port</b></td>
    </tr>
     $$for i in remote;
     <tr>
        <td bgcolor=#cccccc>$$i;</td>
        <td bgcolor=#cccccc>$$remote!$$i;;</td>
        <td><input type=submit name="remote!_del_$$i;" value=Delete></td>
     </tr>
     $$next;
  </table>
  </form>
$$else;
  <i>No remote FastCGIs are currently defined.</i>
$$endif;

<p>
<form action="/apps/admin/regupdate.cgi" method=post>
<input type=hidden name=_base value="$$_base;">
<table>
  <tr>
    <td>Docroot path:</td>
    <td><input type=text size=20 value="/" name="remote!_addbr_text_id1"></td>
  </tr>
  <tr>
    <td>Remote machine:
        <br><font size=-1>hostname:port</font>
    </td>
    <td><input type=text size=20 value="" name=id1></td>
    <td><input type=submit value=Add></td>
  </tr>
</table>
</form>




<dt><font size=+1><b>FastCGI Authorizers</b></font>
<dd>

FastCGI can be used to authenticate client requests (e.g. checking
supplied user/password information against an database).  A FastCGI
authorizer is setup to handle authentication on a portion of the
document tree by specifying a docroot path.  Any client requests to
this portion of the document tree will cause the Web Server to contact
the FastCGI for authorization before allowing the request to proceed.

<p>
$$if authorizers=yes;
  <form action="/apps/admin/regupdate.cgi" method=post>
  <input type=hidden name=_base value="$$_base;">
  <table border=5>
    <tr>
      <td bgcolor=#aaaaaa><b>Docroot path</b></td>
      <td bgcolor=#aaaaaa><b>FastCGI location</b></td>
    </tr>
    $$for i in authorizers;
    <tr>
      <td bgcolor=#cccccc>$$i;</td>
      <td bgcolor=#cccccc>$$authorizers!$$i;;</td>
      <td><input type=submit name="authorizers!_del_$$i;" value=Delete></td>
    </tr>
    $$next;
  </table>
  </form>
$$else;
  <i>No FastCGI authorizers currently defined.</i>
$$endif;

<p>
<form action="/apps/admin/regupdate.cgi" method=post>
<input type=hidden name=_base value="$$_base;">
<table>
  <tr>
    <td>Docroot path:</td>
    <td><input type=text size=20 value="/" name="authorizers!_addbr_text_id1">
    </td>
  </tr>
  <tr>
    <td>FastCGI location:</td>
    <td><input type=text size=20 value="" name="id1"></td>
    <td><input type=submit value=Add></td>
  </tr>
</table>
</form>

</dl>


<dl>
<dt><font size=+1><b>Base environment</b></font>
<dd>
For FastCGI programs started by the automatically by the server on
demand, you can specify extra environment settings to be passed to
them here on startup.

<p>
$$if env=yes;
 <form action="/apps/admin/regupdate.cgi" method=post>
 <input type=hidden name=_base value="$$_base;">
 <table border=5>
    $$for i in env;
    <tr>
      <td bgcolor=#aaaaaa>$$i;=$$env!$$i;;</td>
      <td><input type=submit name="env!_del_$$i;" value=Delete></td>
    </tr>
    $$next;
 </table>
 </form>
$$else;
<i>No extra variables are currently defined.</i>
$$endif;
<p>

<form action="/apps/admin/regupdate.cgi" method=post>
<input type=hidden name=_base value="$$_base;">

<table>
  <tr>
    <td>Variable name:</td>
    <td>
     <input type=text size=20 value="" name="env!_addbr_text_id1">
    </td>
  </tr>
  <tr>
    <td>Variable value:</td>
    <td><input type=text size=20 value="" name=id1></td>
    <td><input type=submit value=Add></td>
  </tr>
</table>
</form>
</dl>
    
$$include /../footer.asp;

