<! Required variables
   server
>
$$set help=/apps/web/docs/modules/log/index.html;
$$set _base=conf!web!servers!$$server;!modules!log;

<title>$$server; - Client Logging</title>

$$set edittitle=Client Logging;
$$include /../header.asp;

This modules logs all client requests to the webserver in a user
specified format.  If multiple virtual servers specify the same log
filename, the file will automatically be shared, saving system
resources.

<p><hr size=1 width=80%>

<form action="/apps/admin/regupdate.cgi" method=post>
<input type=hidden name=_base value="$$_base;">
<input type=hidden name=_redirect value="$$back;">
<table>
  <tr>
     <td>Log filename:</td>
     <td><input type=text size=30 value="$$filename;" name=_add_text_filename>
     </td>
  </tr>
  <tr>
     <td>Format string:</td>
     <td><input type=text size=50 value="$$format;" name=_add_text_format></td>
  </tr>
  <tr>
     <td><br><input type=submit value=Update></td>
  </tr>
</table>
</form>


<form action="/apps/admin/regupdate.cgi" method=post>
<input type=hidden name=_base value="$$_base;">
<select name=_add_text_format>

<option value="%h %l %u %t &quot;%r&quot; %s %b">
NCSA Common Log Format (CLF)

<option value="%h %l %u %t &quot;%r&quot; %s %b &quot;%{Referer}i&quot; &quot;%{User-Agent}i&quot;">
NCSA Combined

<option value="%{Host}i %h %l %u %t &quot;%r&quot; %s %b">
Shared NCSA CLF

<option value="%{Host}i %h %l %u %t &quot;%r&quot; %s %b &quot;%{Referer}i&quot; &quot;%{User-Agent}i&quot;">
Shared NCSA Combined

<option value="%h %l %u %t &quot;%r&quot; %s %b\n&quot;%{Referer}i&quot; &quot;%{User-Agent}i&quot;">
Netscape NSAPI Extended

<option value="%T|%h|%M %U|%{Content-Type}o|%s|%u|%b|%{Cookie}i|%{Referer}i|%{User-Agent}i">
Zeus Extended Logging Format

<option value="Please choose a format" selected>Format Quick pick
</select>

<input type=submit value=Choose>
</form>



<p><hr size=1 width=80%>

<dl>
<dt><b><font size=+1>Quick reference</font></b><p>
<dd>
<b>Common Log Format</b> (CLF) is <tt>%h %l %u %t "%r" %s %b</tt>
<p>

<table border=1 cellspacing=1>
<tr>
 <td>
    %...h
 </td>
 <td>
    Remote host
 </td>
</tr>

<tr>
 <td>
    %...u
 </td>
 <td>
     Remote authenticated user
 </td>
</tr>

<tr>
 <td>
    %...t
 </td>
 <td>
     Time, in Common Log Format time format 
     <br>( e.g. [17/Jun/1996:08:23:09 +0000] )
 </td>
</tr>

<tr>
 <td>
    %...T
 </td>
 <td>
    Time, in short format YYMMDD-hhmmss
 </td>
</tr>

<tr>
 <td>
    %...r
 </td>
 <td>
    First line of client request
 </td>
</tr>

<tr>
 <td>
    %...s
 </td>
 <td>
    Status, e.g. 302
 </td>
</tr>

<tr>
 <td>
    %...b
 </td>
 <td>
    Bytes sent
 </td>
</tr>

<tr>
 <td>
   %...v
 </td>
 <td>
   Server name
 </td>
</tr>

<tr>
 <td>
    %...M
 </td>
 <td>
    Method, e.g. "GET"
 </td>
</tr>

<tr>
 <td>
    %...U
 </td>
 <td>
    URL, e.g. "/index.html"
 </td>
</tr>

<tr>
 <td>
    %...V
 </td>
 <td>
    HTTP version, e.g. "HTTP/1.0"
 </td>
</tr>

<tr>
 <td>
     %...{Foobar}i
 </td>
 <td>
   The contents of Foobar: header line(s) in the request sent by the client
 </td>
</tr>

<tr>
 <td>
     %...{Foobar}o
 </td>
 <td>
     The contents of Foobar: header line(s) in the reply
 </td>
</tr>
</table>
</dl>

 The '...' can be nothing at all (e.g. "%h %u %r %s %b"), or it can
 indicate conditions for inclusion of the item (which will cause it
 to be replaced with '-' if the condition is not met).  

 <p> 

 The forms of condition are a list of HTTP status codes, which may
 or may not be preceded by '!'.  Thus, '%400,501{User-agent}i' logs
 User-agent: on 400 errors and 501 errors (Bad Request, Not
 Implemented) only; '%!200,304,302{Referrer}i' logs Referrer: on all
 requests which did <i>not</i> return some sort of normal status.

 <p>
 
 If the format string is left blank, request output will be logging in
 an extended format compatible with earlier versions of Zeus Server.
 This default format is defined as 

 <p> <tt>%T|%h|%M %U|%{Content-Type}o|%s|%u|%b|%{Cookie}i|%{Referer}i|%{User-Agent}i</tt>
 <p>

 which outputs lines in the form:
 <p>

 <tt>970630-140918|foo.com|GET /||200||750||http://referrer.org/|Mozilla/3.0</tt>

<p> 

See the information in the documentation system for more examples and
information on scaling logging for large numbers of virtual servers.
     
<p>

$$include /../footer.asp;

