<%
# given server, path, dir, type, adds a new alias

# Decode and check input
zap::getrequest { server path dir type }

# Check the input is ok
if { $asp::input(server) == "" || $asp::input(path)=="" || \
	$asp::input(dir) == "" || $asp::input(type) == ""  } {
    zap::error "One or more fields were left blank";
}

# Both the path and dir should being with a '/' or a %..%
if { ! [ string match "\[/%\]*" $asp::input(path) ] } { 
    zap::error "Invalid docroot path" }
if { ! [ string match "\[/%\]*" $asp::input(dir)  ] } { 
    zap::error "Invalid filesystem directory" }

set base "conf!web!servers!$asp::input(server)!modules!map!alias!$asp::input(path)"

# OK, lets do it!
if [ catch {
    reg::addbranch -force "$base"
    reg::add "$base!filepath" $asp::input(dir)   text
    reg::add "$base!type"     $asp::input(type)  text
} result ] {
    if { [ string match "*Access denied" $result ] } {
	asp::authenticate "Registry update"
    }
    zap::error "Unable to add alias: $result"
}

# It succeeded
asp::back
%>

