<%
zap::getrequest { server interval type }
set server   $asp::input(server)
set interval $asp::input(interval)
set type     $asp::input(type)

# Check input is valid
if { $interval != "mins" && $interval != "hours" && $interval != "days" } {
    zap::error "Invalid interval - $interval"
}
if { $type != "bandwidth" && $type != "hits" } {
    zap::error "Invalid type - $type"
}
%>

<! TODO:, add a SSI/asp style include, oh one day! >

<!-- Start of header -->

<html>
<head><title><%=$server%> - Server Statistics</title>
<body bgcolor="#ffffff" link=#990066 vlink=#990066 alink=#990066>

<table>
<tr>
 <td valign=top>
  <img src="/apps/web/title.gif" hspace=10 alt="">
  <p align=right>

  <a href="/apps/admin/docsystem/" target="help" onClick=
     "window.open('','help','resizable=1,width=640,height=500'); return true;">
        <img src="/apps/web/docs.gif" 
        alt="[docs]" align=bottom border=0 hspace=0></a>

  <a href="/apps/web/edit.zap?server=<%=$server%>"><img src="/apps/web/back.gif" 
        alt="[back]" align=bottom border=0 hspace=0></a>
        <a href="/apps/web/"><img src="/apps/web/home.gif" alt="[Controller]" 
        align=bottom border=0></a>
  </td>
  <td valign=top>

<center>
<table width=100% cellpadding=4 cellspacing=0 border=0>
<tr>
 <td>
   <img src="/apps/web/title-editserver.gif" alt="Edit Server ">
 </td>
</tr>
<tr valign=center bgcolor=#cfcfcf >
 <td>
 <font size=+2 color=#000000>Server Statistics (<%=$server%>)</font>
 </td>
</tr>
</table>
</center>
<p>

<title><%=$server%> - Server Statistics</title>

<!-- End of header -->

<%
# Grab my data points

proc propercase { input } {
    set hd [string toupper [string range $input 0 0]]
    set tl [string range $input 1 end ]
    return [join [ list $hd $tl ] ""]
}

set branch   "dynamic!web-modules!$server!stats!$type!$interval"
set Type [propercase "$type" ]

set results [lsort [zap::reglist $branch]]
if { [ llength $results ] < 2 } {
    asp::write "<b>Not enough results to display graph!</b>";
} else {
    set points  {}
    set xlabels {}
    set args    {}
    set x 0;
    set title   ""

    # Work out a title
    if { $interval == "mins" } {
	set title "$Type during the hour "
	scan [lindex $results 0] "%4d%2d%2d-%2d" yr mn dy hr
	append title [clock format [clock scan "$mn/$dy/$yr $hr:00" ] \
		-format "%a %b %d %H:00 %Z %Y" ]
	lappend args "xtitle=[asp::quote_url {minutes past the hour}]"

    } elseif { $interval == "hours" } {
	set title "$Type during the day "
	scan [lindex $results 0] "%4d%2d%2d" yr mn dy
	append title [clock format [clock scan "$mn/$dy/$yr"] \
		-format "%a %b %d %Y"]
	lappend args "xtitle=hour"

    } elseif { $interval == "days" } {
	scan [lindex $results 0]   "%4d%2d%2d" styr stmn stdy
	scan [lindex $results end] "%4d%2d%2d" edyr edmn eddy
	set title "$Type during the period "
	append title [clock format [clock scan "$stmn/$stdy/$styr"] \
		-format "%x" ]
	append title " - "
	append title [clock format [clock scan "$edmn/$eddy/$edyr"] \
		-format "%x" ]
	lappend args "xtitle=day"
    }

    # Now create the points array
    foreach result $results {
	set value [zap::regget $branch!$result]
	if { $interval == "mins" } {
	    scan $result "%*4d%*2d%*2d-%*2d%2d" xcoord
	} elseif { $interval == "hours" } {
	    scan $result "%*4d%*2d%*2d-%2d" xcoord
	} elseif { $interval == "days" } {
	    set xcoord $x
	    scan $result "%4d%2d%2d" y m d
	    lappend xlabels $xcoord,[clock format [clock scan "$m/$d/$y" ] \
		    -format "%b+%d"]
	}
	lappend points "$xcoord,[asp::quote_url $value]"
	incr x;
    }

    # Fill in a few more trimmings
    set yunits ""
    lappend args "points=[join $points ,]"
    if { $type == "hits" } { 
	append yunits "hits" 
    } else {
	append yunits "bytes"
    }
    if { $interval == "mins" } { 
	append yunits "+per+minute"
    } elseif { $interval == "hours" } {
	append yunits "+per+hour"
    } elseif { $interval == "days" } {
	append yunits "+per+day"
    }
    lappend args "ytitle=$yunits"
    lappend args "legend=[asp::quote_url $title]"
    lappend args "xlabels=[join $xlabels ,]"
    lappend args "miny=0"

    # Put the link in
    asp::write "<img src=\"/apps/web/graph.cgi?[join $args &]\">"
}

%>

<p>

<form method=get action=stats.zap>
<input type=hidden name=server value="<%=$server%>">

<select name=type>
<%
if { $type == "hits" } {
    asp::write "<option value=hits>Hits"
    asp::write "<option value=bandwidth>Bandwidth"
} else {
    asp::write "<option value=bandwidth>Bandwidth"
    asp::write "<option value=hits>Hits"
}
%>
</select>

<select name=interval>
<%
if { $interval == "mins" } {
    asp::write "<option value=mins>Last hour"
    asp::write "<option value=hours>Last day"
    asp::write "<option value=days>Last week"
} elseif { $interval == "hours" } {
    asp::write "<option value=hours>Last day"
    asp::write "<option value=mins>Last hour"
    asp::write "<option value=days>Last week"
} else {
    asp::write "<option value=days>Last week"
    asp::write "<option value=mins>Last hour"
    asp::write "<option value=hours>Last day"
}
%>
</select>

<input type=submit value=Display>
</form>

<!-- Start of footer -->

  </td>
 </tr>
</table>

</body>
</html>

<!-- End of footer -->